`timescale 1ps / 1ps
module gazou_gen_d (
  clk,
  rstb,
  tmg_da_en,
  v_c,
  h_c,
  gen_da_en,
  gen_da_r,
  gen_da_g,
  gen_da_b
);

  input clk;
  input rstb;
  input tmg_da_en;
  input [9:0] v_c;
  input [9:0] h_c;
  output gen_da_en;
  output [7:0]gen_da_r;
  output [7:0]gen_da_g;
  output [7:0]gen_da_b;

  reg gen_da_en;
  reg [7:0]gen_da_r;
  reg [7:0]gen_da_g;
  reg [7:0]gen_da_b;
  reg [7:0] bv_c;
  reg [7:0] bh_c;
        
   parameter  size_2 = 20;
   parameter  m_box_v = 300;
   parameter  m_box_h = 250;
   
   

   
//movebox

always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin  
    bv_c <= 8'd0;
    bh_c <= 8'd0;
  end
else
  //if ((p_en==1'b1)&& (tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
  if ((tmg_da_en==1'b1)&&(h_c == 10'd799)&&(v_c == 10'd599))
    if(bv_c<=8'd0)
      if (bh_c>=8'd100)
        begin
          bh_c <= 8'd100;
          bv_c <= 8'd2;
        end
      else
        bh_c <= bh_c +8'd4;
    else
      if (bh_c>=8'd100)
        if(bv_c>=8'd100)
           begin
             bv_c <= 8'd100;
             bh_c <= 8'd98;
           end
        else
          bv_c <= bv_c +8'd4;
      else
        if(bv_c>=8'd100)
          if (bh_c<=8'd0)
            begin
              bh_c <= 8'd0;
              bv_c <= 8'd98;
            end
          else
            bh_c <= bh_c -8'd2;
        else                          
          if (bh_c<=8'd0)
            if(bv_c<=8'd0)
              begin
                bv_c <= 8'd0;
                bh_c <= 8'd2;
              end
            else
               bv_c <= bv_c -8'd2;
  else
    begin
      bv_c <= bv_c;
      bh_c <= bh_c;
    end       
   
always @ (posedge clk or negedge rstb )
if (rstb==1'b0) 
  begin
    gen_da_r <= 8'd0;
    gen_da_g <= 8'd0;
    gen_da_b <= 8'd0;
    gen_da_en <= 1'b0;  end
else
    begin
      gen_da_en <= 1'b0 ;
      gen_da_r <= 8'd0;
      gen_da_g <= 8'd0;
      gen_da_b <= 8'd0;
      //move_bx
      if ((v_c[3:0]==4'd7)||(h_c[3:0]==4'd7))
         begin
           gen_da_en <= 1'b1;
           gen_da_r<=8'd127;
           gen_da_g<=8'd127;
           gen_da_b<=8'd127;
         end
    end

 


   
endmodule








