`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:34:48 07/31/2010
// Design Name:   vga_crt
// Module Name:   C:/home/yokomizo/design/vga_crt/vga_crt/test_vga_crt.v
// Project Name:  vga_crt
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: vga_crt
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module test_vga_crt;

        // Inputs
        reg clk;
        reg rstb;
        reg hanten;
        reg color;
        reg kaityou;
        reg test_mode;

        // Outputs
        //wire p_clk;
        wire out_da_en;
        wire [3:0] out_da_r;
        wire [3:0] out_da_g;
        wire [3:0] out_da_b;
        wire out_vsync_n;
        wire out_hsync_n;
        //wire sync_n;
        wire led_0;
        wire led_1;
        wire led_2;
        wire led_3;
        wire led_4;
        wire [7:0] row;
        wire [7:0] col;
   
        // Instantiate the Unit Under Test (UUT)
        vga_crt uut (
                .clk(clk), 
                .rstb(rstb), 
                //.p_clk(p_clk), 
                .out_da_en(out_da_en), 
                .out_da_r(out_da_r), 
                .out_da_g(out_da_g), 
                .out_da_b(out_da_b), 
                .out_vsync_n(out_vsync_n), 
                .out_hsync_n(out_hsync_n), 
                //.sync_n(sync_n), 
                .hanten(hanten), 
                .color(color), 
                .kaityou(kaityou), 
                .test_mode(test_mode), 
                .led_0(led_0), 
                .led_1(led_1), 
                .led_2(led_2), 
                .led_3(led_3), 
                .led_4(led_4),
                .row(row),
                .col(col)
        );

        initial begin
                // Initialize Inputs
                //clk = 0;
                rstb = 0;
                hanten = 1;
                color = 1;
                kaityou = 1;
                test_mode = 1;

                // Wait 100 ns for global reset to finish
                #100;
                rstb = 1;
        
                // Add stimulus here

        end


        initial begin
                // Initialize Inputs
                clk = 0;
                repeat(500000000) begin
                #12.5;
                clk = 1;
                #12.5;
                clk = 0;
                end
                $stop;
   end
        
endmodule

